commit 82a95c08c0de75a9114bc1c213d07866fc4663f1
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Tue Sep 14 11:14:37 2021

    Do not issue size error for too large array type
    
    The error is to be issued when objects of the type are declared instead.
    
    gcc/ada/
            * gcc-interface/decl.c (validate_size): Do not issue an error if the
            old size has overflowed.

diff --git a/gcc/ada/gcc-interface/decl.c b/gcc/ada/gcc-interface/decl.c
index c71d0d6f396..c27a4eb723e 100644
--- a/gcc/ada/gcc-interface/decl.c
+++ b/gcc/ada/gcc-interface/decl.c
@@ -9133,8 +9133,7 @@ validate_size (Uint uint_size, tree gnu_type, Entity_Id gnat_object,
   /* Issue an error either if the default size of the object isn't a constant
      or if the new size is smaller than it.  */
   if (TREE_CODE (old_size) != INTEGER_CST
-      || TREE_OVERFLOW (old_size)
-      || tree_int_cst_lt (size, old_size))
+      || (!TREE_OVERFLOW (old_size) && tree_int_cst_lt (size, old_size)))
     {
       char buf[128];
       const char *s;

